//Proto17.cs

//audio
datablock AudioProfile(Proto17ShotSound)
{
   filename    = "./LaserPushShot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Proto17BounceSound)
{
   filename    = "./LaserPushBounce.wav";
   description = AudioClosest3d;
   preload = true;
};

//trail
datablock ParticleData(Proto17TrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 0.0 1 1";
	colors[1]	= "0.8 0.2 0.8 0.4";
	sizes[0]	= 0.15;
	sizes[1]	= 0.25;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(Proto17TrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = Proto17TrailParticle;

   useEmitterColors = true;
   uiName = "";
};


//muzzle flash effects
datablock ParticleData(Proto17FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.0 9.0 0.9";
	colors[1]     = "0.4 0.0 4.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Proto17FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Proto17FlashParticle";

   uiName = "";
};

datablock ParticleData(Proto17ExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0 0.9 0.3";
	colors[1]     = "0.9 0 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.5;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Proto17ExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Proto17ExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};


datablock ExplosionData(Proto17Explosion)
{
   //explosionShape = "";
	soundProfile = Proto17BounceSound;

   lifeTimeMS = 150;

   particleEmitter = Proto17ExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.9 0.0 9.0";
   lightEndColor = "0 0 0";
};


AddDamageType("Proto17",   '<bitmap:add-ons/Weapon_Proto17/CI_Proto17> %1',    '%2 <bitmap:add-ons/Weapon_Proto17/CI_Proto17> %1',0.2,1);
datablock ProjectileData(Proto17Projectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 5;
   directDamageType    = $DamageType::Proto17;
   radiusDamageType    = $DamageType::Proto17;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 3;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 4;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 2500;
   verticalImpulse	  = 500;
   explosion           = Proto17Explosion;
   particleEmitter     = Proto17TrailEmitter;
   explodeOnDeath = true;

   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   armingDelay         = 1000;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 1;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 4.0;
   lightColor  = ".75 0 .75";

   uiName = "Proto-17 Laser";
};

//////////
// item //
//////////
datablock ItemData(Proto17Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Proto17.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Proto-17";
	iconName = "./icon_Proto17";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = Proto17Image;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Proto17Image)
{
   // Basic Item properties
   shapeFile = "./Proto17.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = Proto17Projectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = Proto17Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.8;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.75;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= Proto17FlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= Proto17ShotSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";

};

function Proto17Image::onFire(%this,%obj,%slot)
{

	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-15")));
	Parent::onFire(%this,%obj,%slot);	
}

function Proto17Projectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	serverPlay3D(Proto17BounceSound,%obj.getTransform());
}